diff --git a/doc/src/sgml/ref/pgupgrade.sgml b/doc/src/sgml/ref/pgupgrade.sgml
index 848f7e8432..f6bd36ea1c 100644
--- a/doc/src/sgml/ref/pgupgrade.sgml
+++ b/doc/src/sgml/ref/pgupgrade.sgml
@@ -429,27 +429,27 @@ NET STOP postgresql-&majorversion;
     <itemizedlist>
      <listitem>
       <para>
-       All slots on old cluster must be usable, i.e., there are no slots which
-       <structfield>wal_status</structfield> is <literal>lost</literal> (see
+       All slots on the old cluster must be usable, i.e., there are no slots
+       whose <structfield>wal_status</structfield> is <literal>lost</literal> (see
        <xref linkend="view-pg-replication-slots"/>).
       </para>
      </listitem>
      <listitem>
       <para>
-       The output plugin referred by slots on old cluster must be installed on
-       the new PostgreSQL executable directory.
+       The output plugins referenced by the slots on the old cluster must be
+       installed on the new PostgreSQL executable directory.
       </para>
      </listitem>
      <listitem>
       <para>
-       New cluster must have larger
+       The new cluster must have
        <link linkend="guc-max-replication-slots"><varname>max_replication_slots</varname></link>
-       than existing slots on old cluster.
+       configured to value larger than the existing slots on the old cluster.
       </para>
      </listitem>
      <listitem>
       <para>
-       New cluster must be set
+       The new cluster must have
        <link linkend="guc-wal-level"><varname>wal_level</varname></link> as
        <literal>logical</literal>.
       </para>
